SystemOrganization addCategory: #'Kernel-ClassBuilderIR'!

IRVisitor subclass: #MethodFieldUpdater
	instanceVariableNames: 'methodModification'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-ClassBuilderIR'!

!MethodFieldUpdater methodsFor: 'private' stamp: 'CamilloBruni 3/28/2011 18:43'!
decompile: aMethod

	^ OCBytecodeDecompiler new decompile: aMethod! !

!MethodFieldUpdater methodsFor: 'accessing' stamp: 'ToonVerwaest 3/27/2011 21:17'!
recompileMethod: method withSelector: selector to: aClass
	| ir newMethod |
	ir := self decompile: method.
	ir accept: self.
	newMethod := ir compiledMethodWith: method trailer.
	newMethod selector: selector.
	newMethod methodClass: aClass.
	aClass methodDict at: selector put: newMethod! !

!MethodFieldUpdater methodsFor: 'accessing' stamp: 'ToonVerwaest 3/27/2011 19:51'!
transformAll: methodDict using: aMethodModification to: aClass
	methodModification := aMethodModification.
	methodDict keysAndValuesDo: [ :selector :method |
		self recompileMethod: method withSelector: selector to: aClass ]! !

!MethodFieldUpdater methodsFor: 'visiting' stamp: 'ToonVerwaest 3/28/2011 17:52'!
visitInstVarAccess: anInstVarAccess
	(methodModification modificationAt: anInstVarAccess number)
		applyToIR: anInstVarAccess! !

!MethodFieldUpdater methodsFor: 'visiting' stamp: 'ToonVerwaest 3/28/2011 20:01'!
visitPushLiteral: aPushLiteral
	(aPushLiteral literal isKindOf: AbstractFieldModification)
		ifTrue: [
			aPushLiteral literal
				rewriteIR: aPushLiteral
				usingModification: methodModification ]! !

!ShiftedField methodsFor: '*Kernel-ClassBuilderIR-recompiling' stamp: 'ToonVerwaest 3/28/2011 20:27'!
applyToIR: aFieldAccess
	aFieldAccess number: aFieldAccess number + shift! !

!RemovedField methodsFor: '*Kernel-ClassBuilderIR-recompiling' stamp: 'ToonVerwaest 3/28/2011 18:07'!
applyToIR: aFieldAccess
	| nodes |
	nodes := aFieldAccess isRead
				ifTrue: [ self buildInvalidReadIRNodes ]
				ifFalse: [ self buildInvalidWriteIRNodes ].
	aFieldAccess sequence
		replaceNode: aFieldAccess
		withNodes: nodes! !

!RemovedField methodsFor: '*Kernel-ClassBuilderIR-recompiling' stamp: 'ErwannNiko 3/30/2011 15:41'!
buildInvalidReadIRNodes
	^ {
		IRInstruction pushLiteral: self.
		IRInstruction send: #invalidRead.
	}! !

!RemovedField methodsFor: '*Kernel-ClassBuilderIR-recompiling' stamp: 'ToonVerwaest 3/28/2011 19:54'!
buildInvalidWriteIRNodes
	^ {
		IRInstruction pushLiteral: self.
		IRInstruction send: #invalidWrite.
		IRInstruction popTop.
	}! !

!RemovedField methodsFor: '*Kernel-ClassBuilderIR-recompiling' stamp: 'ErwannNiko 3/30/2011 16:36'!
rewriteIR: aNode usingModification: aMethodModification
	| addedField  newSlot |
	addedField := aMethodModification
		 addedSlotNamed: originalSlot name ifAbsent: [ ^ nil ].
	newSlot := addedField newSlot.
self	halt.
	aNode nextInstruction delete.
	aNode replaceWith: (IRInstruction pushInstVar: newSlot index ).
	! !

!ModifiedField methodsFor: '*Kernel-ClassBuilderIR-recompiling' stamp: 'ToonVerwaest 3/28/2011 17:53'!
applyToIR: aFieldAccess
	aFieldAccess number: self newFieldIndex! !

!AbstractFieldModification methodsFor: '*Kernel-ClassBuilderIR-recompiling' stamp: 'ToonVerwaest 3/28/2011 17:52'!
applyToIR: aFieldAccess! !

!AbstractFieldModification methodsFor: '*Kernel-ClassBuilderIR-recompiling' stamp: 'ToonVerwaest 3/28/2011 18:29'!
rewriteIR: aNode usingModification: aMethodModification! !
